#!/usr/bin/perl -w
use strict;

# LOOP THRU ALL THE Fl_ FILES
foreach my $file ( glob("Fl_*.html") ) {

    if ( $file =~ /_methods.html/ ) { next; }	# skip files we generate

    # IN: Fl_foo.html OUT: Fl_foo_methods.html
    my $infile = $file;
    my $outfile = $file; $outfile =~ s/.html$/_methods.html/;

    unless ( open(IN, "<$infile") )
        { print STDERR "$infile: $!\n"; exit(1); }
    unless ( open(OUT, ">$outfile") )
        { print STDERR "$outfile: $!\n"; exit(1); }

    print STDERR "Generating: $outfile\n";

    # PARSE HTML FILE, ASSUME FORMAT IS:
    #    <H#>Methods</H#>                  <-- marks start
    #    <LI><A HREF="#foo">foo</A></LI>
    #    <LI><A HREF="#bar">bar</A></LI>
    #    <H#>XXX</H#>                      <-- marks end
    #
    my $method = 0;
    while (<IN>) {
        if ( m%<H\d>Methods</H\d>%i )
	    { $method = 1; }
	elsif ( m%<H\d>% )
	    { $method = 0; }
	elsif ( $method && m%<li>(<a href=["]*)(.*/a>)%i )
	    { print OUT (($method>1)?",\n":"") . "$1$infile$2"; $method++; }
    }
    print OUT "\n";
    close(IN);
    close(OUT);
}
exit(0);
